﻿--local L = LibStub:GetLibrary("AceLocale-3.0"):GetLocale("Broker_LFD")
local LFD = CreateFrame("Frame", "Broker_LFD")

LFD.obj = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_LFD", {type = "data source", icon = "Interface\\LFGFrame\\BattlenetWorking0", label = "LFD"})

local point, relativeTo, relativePoint, xOfs, yOfs = LFDSearchStatus:GetPoint();

LFD:RegisterEvent("LFG_UPDATE");

LFD:SetScript("OnEvent", function()
	--MiniMapLFGFrame:Hide();
end)

function LFD.obj.OnTooltipShow(self)
	local mode, submode = GetLFGMode();
	if ( mode == "queued" ) then
		LFDSearchStatus:SetPoint("TOPRIGHT", self, "TOPRIGHT", -10, -10);
		LFDSearchStatus:Show();
	elseif ( mode == "proposal" ) then
		GameTooltip:SetOwner(LFD, "ANCHOR_LEFT");
		GameTooltip:SetText(LOOKING_FOR_DUNGEON);
		GameTooltip:AddLine(DUNGEON_GROUP_FOUND_TOOLTIP, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, 1);
		GameTooltip:AddLine(" ");
		GameTooltip:AddLine(CLICK_HERE_FOR_MORE_INFO, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, 1);
		GameTooltip:Show();
	elseif ( mode == "rolecheck" ) then
		GameTooltip:SetOwner(LFD, "ANCHOR_LEFT");
		GameTooltip:SetText(LOOKING_FOR_DUNGEON);
		GameTooltip:AddLine(ROLE_CHECK_IN_PROGRESS_TOOLTIP, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, 1);
		GameTooltip:Show();
	elseif ( mode == "listed" ) then
		GameTooltip:SetOwner(LFD, "ANCHOR_LEFT");
		GameTooltip:SetText(LOOKING_FOR_RAID);
		GameTooltip:AddLine(YOU_ARE_LISTED_IN_LFR, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, 1);
		GameTooltip:Show();
	elseif ( mode == "lfgparty" ) then
		GameTooltip:SetOwner(LFD, "ANCHOR_LEFT");
		GameTooltip:SetText(LOOKING_FOR_DUNGEON);
		GameTooltip:AddLine(YOU_ARE_IN_DUNGEON_GROUP, NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b, 1);
		GameTooltip:Show();
	end
end

function LFD.obj.OnClick(self, button)
	local mode, submode = GetLFGMode();
	if ( button == "RightButton" or mode == "lfgparty" or mode == "abandonedInDungeon") then
		--Display dropdown
		local yOffset;
		if ( mode == "queued" ) then
			MiniMapLFGFrameDropDown.point = "TOPRIGHT";
			MiniMapLFGFrameDropDown.relativePoint = "BOTTOMLEFT";
			yOffset = 0;
		else
			MiniMapLFGFrameDropDown.point = nil;
			MiniMapLFGFrameDropDown.relativePoint = nil;
			yOffset = -5;
		end
		ToggleDropDownMenu(1, nil, MiniMapLFGFrameDropDown, self, 0, yOffset);
	elseif ( mode == "proposal" ) then
		if ( not LFDDungeonReadyPopup:IsShown() ) then
			PlaySound("igCharacterInfoTab");
			StaticPopupSpecial_Show(LFDDungeonReadyPopup);
		end
	elseif ( mode == "queued" or mode == "rolecheck" ) then
		ToggleLFDParentFrame();
	elseif ( mode == "listed" ) then
		ToggleLFRParentFrame();
	else
		ToggleLFDParentFrame();
	end

end

function LFD.obj.OnLeave(self)
	GameTooltip:Hide();
	LFDSearchStatus:Hide();
	LFDSearchStatus:SetParent(MiniMapLFGFrame);
	LFDSearchStatus:SetPoint(point, relativeTo, relativePoint, xOfs, yOfs);
end
